import java.util.*;

public class City {

  private Location geo_center;
  private String city;
  private ArrayList<Location> t_loc;

  private Boolean library = false;
  private Boolean university = false;

  public City(ArrayList<Location> table_loc) {
    this.t_loc = table_loc;

    Scanner sc = new Scanner(System.in);

		System.out.println("--------------------------------------------------");
		System.out.println("Paramètres pour le choix de la ville:");
		System.out.println("Besoin d'une bibliothèque ? (y/n)");
		if(sc.nextLine().equals("y"))
		this.library = true;
		System.out.println("Fini");

    System.out.println("--------------------------------------------------");
		System.out.println("Calcul du centre géogrpahique...");
		this.calcul_geo_center();
		System.out.println("Centre x: " + this.get_geo_center().get_x() + ", y:" + this.get_geo_center().get_y());
		System.out.println("Fini");

		System.out.println("--------------------------------------------------");
		System.out.println("Correction centre par rapport aux poids...");
		System.out.println("Fini");

		System.out.println("--------------------------------------------------");
		System.out.println("Choix de la ville...");
		System.out.println("Fini");
  }

  /**
   * Get geographical center point
   * @return Location, position x and y
   */
  public Location get_geo_center(){
    return this.geo_center;
  }

  /**
   * Get city name
   * @return String, city name
   */
  public String get_city(){
    return this.city;
  }

  /**
   * Pint all location
   */
  public void show_locs(){
    this.t_loc.forEach((l) -> System.out.println("x: " + l.get_x() + ", y: " + l.get_y()));
  }

  /**
   * Print all city parameters state
   */
  public void show_params(){
    System.out.println("--------------------------------------------------");
		System.out.println("Paramètres de la ville:");
    System.out.println("Bibliothèque:   " + this.library);
    System.out.println("Université:     " + this.university);
		System.out.println("Fini");
  }

  /**
   * Calcul the geographic center of the table points
   */
  private void calcul_geo_center(){
    Location c = new Location(0,0);
    float x = 0;
    float y = 0;

    for (Location l : this.t_loc) {
      x += l.get_x();
      y += l.get_y();
		}

    c.set_x(x/this.t_loc.size());
    c.set_y(y/this.t_loc.size());

    this.geo_center = c;
  }

  /**
   * [point_weight description]
   */
  private void point_weight(){

  }

  private void get_nearest_city(Location loc){

  }
}
